unit dm_data;

interface

uses
  SysUtils, Classes, Dialogs, Controls, DB, rDBGrid,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.ODBC, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, rDBGridSorter_FireDac, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FireDAC.VCLUI.Wait, FireDAC.Comp.UI,
  FireDAC.Phys.ODBCBase, FireDAC.Phys.MSAcc, FireDAC.Phys.MSAccDef;

type
  TDMData = class(TDataModule)
    dsEmp: TDataSource;
    dsLookupProducts: TDataSource;
    dsCust: TDataSource;
    dsProducts: TDataSource;
    dsEmpSum3: TDataSource;
    dsEmpSum2: TDataSource;
    dsEmpSum1: TDataSource;
    dsCategories: TDataSource;
    dsProdCatMatch: TDataSource;
    dsEmpList: TDataSource;
    dsValDef: TDataSource;
    dsOrders: TDataSource;
    dsOrderDetails: TDataSource;
    DBCon: TFDConnection;
    qEmp: TFDQuery;
    rDBGridSorter: TrDBGridSorter_FireDac;
    qEmpEmployeeID: TFDAutoIncField;
    qEmpLastName: TWideStringField;
    qEmpFirstName: TWideStringField;
    qEmpTitle: TWideStringField;
    qEmpTitleOfCourtesy: TWideStringField;
    qEmpBirthDate: TSQLTimeStampField;
    qEmpHireDate: TSQLTimeStampField;
    qEmpPartTime: TBooleanField;
    qEmpAddress: TWideStringField;
    qEmpCity: TWideStringField;
    qEmpRegion: TWideStringField;
    qEmpPostalCode: TWideStringField;
    qEmpCountry: TWideStringField;
    qEmpHomePhone: TWideStringField;
    qEmpExtension: TWideStringField;
    qEmpPhoto: TBlobField;
    qEmpNotes: TWideMemoField;
    qEmpReportsTo: TIntegerField;
    qEmpSalary: TFloatField;
    qCust: TFDQuery;
    qCustCustomerID: TWideStringField;
    qCustCompanyName: TWideStringField;
    qCustContactName: TWideStringField;
    qCustContactTitle: TWideStringField;
    qCustAddress: TWideStringField;
    qCustCity: TWideStringField;
    qCustRegion: TWideStringField;
    qCustPostalCode: TWideStringField;
    qCustCountry: TWideStringField;
    qCustPhone: TWideStringField;
    qCustFax: TWideStringField;
    qCustEmail: TWideStringField;
    qCustWWW: TWideStringField;
    qCustActive: TWideStringField;
    qProducts: TFDQuery;
    qProductsProductID: TFDAutoIncField;
    qProductsProductName: TWideStringField;
    qProductsSupplierID: TIntegerField;
    qProductsCategoryID: TIntegerField;
    qProductsQuantityPerUnit: TWideStringField;
    qProductsUnitPrice: TCurrencyField;
    qProductsUnitsInStock: TSmallintField;
    qProductsUnitsOnOrder: TSmallintField;
    qProductsReorderLevel: TSmallintField;
    qProductsDiscontinued: TBooleanField;
    qProductsStockLevel: TWideStringField;
    qProductsProductColor: TWideStringField;
    qLookupProducts: TFDQuery;
    aqSuppliers: TFDQuery;
    aqCategories: TFDQuery;
    aqSuppliersSupplierID: TFDAutoIncField;
    aqSuppliersCompanyName: TWideStringField;
    aqSuppliersContactName: TWideStringField;
    aqSuppliersCity: TWideStringField;
    aqCategoriesCategoryID: TFDAutoIncField;
    aqCategoriesCategoryName: TWideStringField;
    qOrders: TFDQuery;
    qOrderDetails: TFDQuery;
    qOrdersOrderID: TFDAutoIncField;
    qOrdersCustomerID: TWideStringField;
    qOrdersEmployeeID: TIntegerField;
    qOrdersOrderDate: TSQLTimeStampField;
    qOrdersRequiredDate: TSQLTimeStampField;
    qOrdersShippedDate: TSQLTimeStampField;
    qOrdersShipVia: TIntegerField;
    qOrdersFreight: TCurrencyField;
    qOrdersShipName: TWideStringField;
    qOrdersShipAddress: TWideStringField;
    qOrdersShipCity: TWideStringField;
    qOrdersShipRegion: TWideStringField;
    qOrdersShipPostalCode: TWideStringField;
    qOrdersShipCountry: TWideStringField;
    qOrderDetailsOrderDetailID: TFDAutoIncField;
    qOrderDetailsOrderID: TIntegerField;
    qOrderDetailsProductID: TIntegerField;
    qOrderDetailsProductName: TWideStringField;
    qOrderDetailsUnitPrice: TCurrencyField;
    qOrderDetailsQuantity: TSmallintField;
    qOrderDetailsDiscount: TSingleField;
    qOrderDetailsPrice: TFloatField;
    qMatValues: TFDQuery;
    qTempValues: TFDQuery;
    qMatValuesID: TFDAutoIncField;
    qMatValuesMaterialID: TIntegerField;
    qMatValuesValueID: TIntegerField;
    qMatValuesNumValue: TFloatField;
    qMatValuesNote: TWideStringField;
    qTempValuesID: TFDAutoIncField;
    qTempValuesMaterialID: TIntegerField;
    qTempValuesValueID: TIntegerField;
    qTempValuesTemperature: TIntegerField;
    qTempValuesNumValue: TFloatField;
    qValDef: TFDQuery;
    qTemperatures: TFDQuery;
    qValDefValueID: TIntegerField;
    qValDefValueName: TWideStringField;
    qValDefValueUnit: TWideStringField;
    qTemperaturesTemperature: TIntegerField;
    qCategories: TFDQuery;
    qProdCatMatch: TFDQuery;
    qCategoriesCategoryID: TFDAutoIncField;
    qCategoriesCategoryName: TWideStringField;
    qProdCatMatchProductID: TIntegerField;
    qProdCatMatchCategoryID: TIntegerField;
    qEmpAdr: TFDQuery;
    qEmpSum1: TFDQuery;
    qEmpSum2: TFDQuery;
    qEmpSum3: TFDQuery;
    qEmpList: TFDQuery;
    qTitleList: TFDQuery;
    qTitleCList: TFDQuery;
    qEmpAdrAddr: TWideStringField;
    qEmpSum1EmployeeID: TWideStringField;
    qEmpSum1LastName: TIntegerField;
    qEmpSum1Salary: TFloatField;
    qEmpSum2EmployeeID: TWideStringField;
    qEmpSum2LastName: TIntegerField;
    qEmpSum2Salary: TFloatField;
    qEmpSum3SumOfLastName: TIntegerField;
    qEmpSum3SumOfSalary: TFloatField;
    qEmpSum3SumOfPartTime: TFloatField;
    qEmpSum3SumOfCountry: TFloatField;
    qEmpSum3SumOfPhoto: TFloatField;
    qEmpListEmployeeID: TFDAutoIncField;
    qEmpListFullName: TWideStringField;
    qTitleListTitle: TWideStringField;
    qTitleCListTitleOfCourtesy: TWideStringField;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDPhysMSAccessDriverLink1: TFDPhysMSAccessDriverLink;
    qLookupProductsProductID: TFDAutoIncField;
    qLookupProductsProductName: TWideStringField;
    qLookupProductsSupplierID: TIntegerField;
    qLookupProductsCategoryID: TIntegerField;
    qLookupProductsQuantityPerUnit: TWideStringField;
    qLookupProductsUnitPrice: TCurrencyField;
    qLookupProductsUnitsInStock: TSmallintField;
    qLookupProductsUnitsOnOrder: TSmallintField;
    qLookupProductsReorderLevel: TSmallintField;
    qLookupProductsDiscontinued: TBooleanField;
    qLookupProductsStockLevel: TWideStringField;
    qLookupProductsProductColor: TWideStringField;
    qLookupProductsSupplier: TWideStringField;
    qLookupProductsCategory: TWideStringField;
    qEmpListTitle: TWideStringField;
    qTreeData: TFDQuery;
    qTreeDataID: TFDAutoIncField;
    qTreeDataParentID: TSmallintField;
    qTreeDataNodeCode: TWideStringField;
    qTreeDataNodeName: TWideStringField;
    qTreeDataSomeText1: TWideStringField;
    qTreeDataSomeNumber1: TSmallintField;
    qTreeDataSomeDate1: TSQLTimeStampField;
    dsTreeData: TDataSource;
    qEmpNotesRTF: TWideMemoField;
    procedure qEmpAfterPost(DataSet: TDataSet);
    procedure qEmpAfterDelete(DataSet: TDataSet);
    procedure qEmpBeforeDelete(DataSet: TDataSet);
    procedure DataModuleCreate(Sender: TObject);
  private
  public
    AfterUpdate: TDataSetNotifyEvent;
    function DBConnect: string;
    procedure DBDisConnect;
    procedure ExecSQL(cmd: string);
    procedure SetQuery(DataSet: TDataSet; SQL: string);
    procedure SetQueryParam(DataSet: TDataSet; ParamName, ParamStr: string);
    procedure DoAfterUpdate(DataSet: TDataSet);
  end;

var
  DMData: TDMData;

implementation

{$R *.dfm}
uses RosiCompGlobalCfg, rstring, rdlg, rtool, rdbtool;

const
  DefaultDB = 'data\Demo.mdb';
  //  ConStr = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=';
  // ConStr = 'Provider=Microsoft.ACE.OLEDB.12.0;Data Source=';

procedure TDMData.DataModuleCreate(Sender: TObject);
begin
  RosiCompConfig.rDBFilterCfg.FilterWildCardChar:='%';
end;

function TDMData.DBConnect: string;
begin
  Result:='';
  DBDisConnect;
  try
    DBCon.Params.Values['Database']:=GetAppPath + DefaultDB;
    DBCon.Open;
    Result:=GetAppPath + DefaultDB;
  except
    on E: exception do
      ShowErr(sError, E, true);
  end;
end;

procedure TDMData.DBDisConnect;
begin
  DBCon.Close;
end;

procedure TDMData.SetQuery(DataSet: TDataSet; SQL: string);
begin
  DataSet.Close;
  (DataSet as TFDQuery).SQL.Text:=SQL;
end;

procedure TDMData.SetQueryParam(DataSet: TDataSet; ParamName: string; ParamStr: string);
begin
  DataSet.Close;
  (DataSet as TFDQuery).ParamByName(ParamName).Value:=ParamStr;
end;

procedure TDMData.DoAfterUpdate(DataSet: TDataSet);
begin
  if Assigned(AfterUpdate) then
    AfterUpdate(DataSet);
end;

procedure TDMData.ExecSQL(cmd: string);
begin
  DBCon.ExecSQL(cmd);
end;

procedure TDMData.qEmpAfterPost(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

procedure TDMData.qEmpBeforeDelete(DataSet: TDataSet);
begin
  if DlgQ(rstring.sDeleteQ) <> mrYes then
    Abort;
end;

procedure TDMData.qEmpAfterDelete(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

end.
