unit dm_data;

interface

uses
  SysUtils, Classes, Dialogs, Controls, DB, rDBGrid,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.ODBC, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, rDBGridSorter_FireDac, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FireDAC.VCLUI.Wait, FireDAC.Comp.UI,
  FireDAC.Phys.ODBCBase, FireDAC.Phys.MSAcc, FireDAC.Phys.FB,
  FireDAC.Phys.FBDef, FireDAC.Phys.MSAccDef, FireDAC.VCLUI.Login;

type
  TDMData = class(TDataModule)
    dsEmp: TDataSource;
    dsLookupProducts: TDataSource;
    dsCust: TDataSource;
    dsProducts: TDataSource;
    dsEmpSum3: TDataSource;
    dsEmpSum2: TDataSource;
    dsEmpSum1: TDataSource;
    dsCategories: TDataSource;
    dsProdCatMatch: TDataSource;
    dsEmpList: TDataSource;
    dsValDef: TDataSource;
    dsOrders: TDataSource;
    dsOrderDetails: TDataSource;
    DBCon: TFDConnection;
    qEmp: TFDQuery;
    rDBGridSorter: TrDBGridSorter_FireDac;
    qCust: TFDQuery;
    qProducts: TFDQuery;
    qLookupProducts: TFDQuery;
    aqSuppliers: TFDQuery;
    aqCategories: TFDQuery;
    qOrders: TFDQuery;
    qOrderDetails: TFDQuery;
    qMatValues: TFDQuery;
    qTempValues: TFDQuery;
    qValDef: TFDQuery;
    qTemperatures: TFDQuery;
    qCategories: TFDQuery;
    qProdCatMatch: TFDQuery;
    qEmpAdr: TFDQuery;
    qEmpSum1: TFDQuery;
    qEmpSum2: TFDQuery;
    qEmpSum3: TFDQuery;
    qEmpList: TFDQuery;
    qTitleList: TFDQuery;
    qTitleCList: TFDQuery;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDPhysMSAccessDriverLink1: TFDPhysMSAccessDriverLink;
    qLookupProductsSupplier: TWideStringField;
    qLookupProductsCategory: TWideStringField;
    qEmpEMPLOYEEID: TIntegerField;
    qEmpLASTNAME: TStringField;
    qEmpFIRSTNAME: TStringField;
    qEmpTITLE: TStringField;
    qEmpTITLEOFCOURTESY: TStringField;
    qEmpBIRTHDATE: TDateField;
    qEmpHIREDATE: TDateField;
    qEmpPARTTIME: TSmallintField;
    qEmpADDRESS: TStringField;
    qEmpCITY: TStringField;
    qEmpREGION: TStringField;
    qEmpPOSTALCODE: TStringField;
    qEmpCOUNTRY: TStringField;
    qEmpHOMEPHONE: TStringField;
    qEmpEXTENSION: TStringField;
    qEmpPHOTO: TBlobField;
    qEmpNOTES: TMemoField;
    qEmpREPORTSTO: TIntegerField;
    qEmpSALARY: TFloatField;
    qEmpAdrADDR: TStringField;
    qEmpSum1EMPLOYEEID: TStringField;
    qEmpSum1LASTNAME: TIntegerField;
    qEmpSum1SALARY: TFloatField;
    qEmpSum2EMPLOYEEID: TStringField;
    qEmpSum2LASTNAME: TIntegerField;
    qEmpSum2SALARY: TFloatField;
    qEmpSum3SUMOFLASTNAME: TIntegerField;
    qEmpSum3SUMOFSALARY: TFloatField;
    qEmpSum3SUMOFPARTTIME: TLargeintField;
    qEmpSum3SUMOFCOUNTRY: TLargeintField;
    qEmpSum3SUMOFPHOTO: TLargeintField;
    qEmpListEMPLOYEEID: TIntegerField;
    qEmpListFULLNAME: TStringField;
    qEmpListTITLE: TStringField;
    qTitleListTITLE: TStringField;
    qCustCUSTOMERID: TStringField;
    qCustCOMPANYNAME: TStringField;
    qCustCONTACTNAME: TStringField;
    qCustCONTACTTITLE: TStringField;
    qCustADDRESS: TStringField;
    qCustCITY: TStringField;
    qCustREGION: TStringField;
    qCustPOSTALCODE: TStringField;
    qCustCOUNTRY: TStringField;
    qCustPHONE: TStringField;
    qCustFAX: TStringField;
    qCustEMAIL: TStringField;
    qCustWWW: TStringField;
    qCustACTIVE: TStringField;
    qOrderDetailsORDERDETAILID: TIntegerField;
    qOrderDetailsORDERID: TIntegerField;
    qOrderDetailsPRODUCTID: TIntegerField;
    qOrderDetailsPRODUCTNAME: TStringField;
    qOrderDetailsUNITPRICE: TFloatField;
    qOrderDetailsQUANTITY: TIntegerField;
    qOrderDetailsDISCOUNT: TFloatField;
    qOrderDetailsPRICE: TFloatField;
    qProductsPRODUCTID: TIntegerField;
    qProductsPRODUCTNAME: TStringField;
    qProductsSUPPLIERID: TIntegerField;
    qProductsCATEGORYID: TIntegerField;
    qProductsQUANTITYPERUNIT: TStringField;
    qProductsUNITSINSTOCK: TIntegerField;
    qProductsUNITSONORDER: TIntegerField;
    qProductsREORDERLEVEL: TIntegerField;
    qProductsDISCONTINUED: TSmallintField;
    qProductsSTOCKLEVEL: TStringField;
    qProductsPRODUCTCOLOR: TStringField;
    qProductsUNITPRICE: TFloatField;
    qCategoriesCATEGORYID: TIntegerField;
    qCategoriesCATEGORYNAME: TStringField;
    qProdCatMatchPRODUCTID: TIntegerField;
    qProdCatMatchCATEGORYID: TIntegerField;
    qLookupProductsPRODUCTID: TIntegerField;
    qLookupProductsPRODUCTNAME: TStringField;
    qLookupProductsSUPPLIERID: TIntegerField;
    qLookupProductsCATEGORYID: TIntegerField;
    qLookupProductsQUANTITYPERUNIT: TStringField;
    qLookupProductsUNITSINSTOCK: TIntegerField;
    qLookupProductsUNITSONORDER: TIntegerField;
    qLookupProductsREORDERLEVEL: TIntegerField;
    qLookupProductsDISCONTINUED: TSmallintField;
    qLookupProductsSTOCKLEVEL: TStringField;
    qLookupProductsPRODUCTCOLOR: TStringField;
    qLookupProductsUNITPRICE: TFloatField;
    aqSuppliersSUPPLIERID: TIntegerField;
    aqSuppliersCOMPANYNAME: TStringField;
    aqSuppliersCONTACTNAME: TStringField;
    aqSuppliersCITY: TStringField;
    aqCategoriesCATEGORYID: TIntegerField;
    aqCategoriesCATEGORYNAME: TStringField;
    qValDefVALUEID: TIntegerField;
    qValDefVALUENAME: TStringField;
    qValDefVALUEUNIT: TStringField;
    qMatValuesID: TIntegerField;
    qMatValuesMATERIALID: TIntegerField;
    qMatValuesVALUEID: TIntegerField;
    qMatValuesNOTE: TMemoField;
    qMatValuesNUMVALUE: TFloatField;
    qTemperaturesTEMPERATURE: TIntegerField;
    qTempValuesID: TIntegerField;
    qTempValuesMATERIALID: TIntegerField;
    qTempValuesVALUEID: TIntegerField;
    qTempValuesTEMPERATURE: TIntegerField;
    qTempValuesNUMVALUE: TFloatField;
    qTitleCListTITLEOFCOURTESY: TStringField;
    qOrdersORDERID: TIntegerField;
    qOrdersCUSTOMERID: TStringField;
    qOrdersEMPLOYEEID: TIntegerField;
    qOrdersORDERDATE: TDateField;
    qOrdersREQUIREDDATE: TDateField;
    qOrdersSHIPPEDDATE: TDateField;
    qOrdersSHIPVIA: TIntegerField;
    qOrdersSHIPNAME: TStringField;
    qOrdersSHIPADDRESS: TStringField;
    qOrdersSHIPCITY: TStringField;
    qOrdersSHIPREGION: TStringField;
    qOrdersSHIPPOSTALCODE: TStringField;
    qOrdersSHIPCOUNTRY: TStringField;
    qOrdersFREIGHT: TFloatField;
    qTreeData: TFDQuery;
    dsTreeData: TDataSource;
    qTreeDataID: TIntegerField;
    qTreeDataPARENTID: TIntegerField;
    qTreeDataNODECODE: TStringField;
    qTreeDataNODENAME: TStringField;
    qTreeDataSOMETEXT1: TStringField;
    qTreeDataSOMENUMBER1: TIntegerField;
    qTreeDataSOMEDATE1: TDateField;
    qEmpNOTESRTF: TMemoField;
    FDGUIxLoginDialog1: TFDGUIxLoginDialog;
    procedure qEmpAfterPost(DataSet: TDataSet);
    procedure qEmpAfterDelete(DataSet: TDataSet);
    procedure qEmpBeforeDelete(DataSet: TDataSet);
  private
  public
    AfterUpdate: TDataSetNotifyEvent;
    function DBConnect: string;
    procedure DBDisConnect;
    procedure ExecSQL(cmd: string);
    procedure SetQuery(DataSet: TDataSet; SQL: string);
    procedure SetQueryParam(DataSet: TDataSet; ParamName, ParamStr: string);
    procedure DoAfterUpdate(DataSet: TDataSet);
  end;

var
  DMData: TDMData;

implementation

{$R *.dfm}
uses rstring, rdlg, rtool, rdbtool;

const
  DefaultDB25 = 'data\Demo.fdb';
  DefaultDB30 = 'data\Demo30.fdb';
  //  ConStr = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=';
  // ConStr = 'Provider=Microsoft.ACE.OLEDB.12.0;Data Source=';

function TDMData.DBConnect: string;
begin
  Result:='';
  DBDisConnect;
  try
    try
      DBCon.Params.Values['Database']:=GetAppPath + DefaultDB25;
      DBCon.Open;
    except
      DBCon.Params.Values['Database']:=GetAppPath + DefaultDB30;
      DBCon.Open;
    end;
    Result:=DBCon.Params.Values['Database'];
  except
    on E: exception do
      ShowErr(sError, E, true);
  end;
end;

procedure TDMData.DBDisConnect;
begin
  DBCon.Close;
end;

procedure TDMData.SetQuery(DataSet: TDataSet; SQL: string);
begin
  DataSet.Close;
  (DataSet as TFDQuery).SQL.Text:=SQL;
end;

procedure TDMData.SetQueryParam(DataSet: TDataSet; ParamName: string; ParamStr: string);
begin
  DataSet.Close;
  (DataSet as TFDQuery).ParamByName(ParamName).Value:=ParamStr;
end;

procedure TDMData.DoAfterUpdate(DataSet: TDataSet);
begin
  if Assigned(AfterUpdate) then
    AfterUpdate(DataSet);
end;

procedure TDMData.ExecSQL(cmd: string);
begin
  DBCon.ExecSQL(cmd);
end;

procedure TDMData.qEmpAfterPost(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

procedure TDMData.qEmpBeforeDelete(DataSet: TDataSet);
begin
  if DlgQ(rstring.sDeleteQ) <> mrYes then
    Abort;
end;

procedure TDMData.qEmpAfterDelete(DataSet: TDataSet);
begin
  DoAfterUpdate(DataSet);
end;

end.
