unit f_ctrlgrid2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, PropSaveMain, DB, Grids, DBGrids,
  rDBGrid, StdCtrls, DBCtrls, rDBComponents, Mask, rDBCtrlGridEx, rHTMLLabel;

type
  TCtrlGrid2 = class(TForm)
    Label2: TrHTMLLabel;
    PropSaveMain1: TPropSaveMain;
    ScrollBox: TrScrollBoxEx;
    CtrlGrid: TrDBCtrlGridEx;
    rDBEdit4: TrDBEdit;
    rDBEdit5: TrDBEdit;
    rDBEdit6: TrDBEdit;
    rDBCheckBox2: TrDBCheckBox;
    rDBMemo2: TrDBMemo;
    grEmpDummy: TrDBGrid;
    cbTitleOfCourtesy: TrDBComboBox;
    cbTitle: TrDBComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CtrlGridPaintPanel(DBCtrlGrid: TrDBCtrlGridEx; Panel: TDBCtrlPanel; Selected, Focused: Boolean);
    procedure CtrlGridPaintPanelBackground(DBCtrlGrid: TrDBCtrlGridEx; Panel: TDBCtrlPanel; Selected: Boolean; var Color: TColor);
    procedure AfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CtrlGrid2: TCtrlGrid2;

implementation

uses dm_data, f_main, rstring, rdlg, rdbtool,
  dm_rdbaction;
{$R *.dfm}

procedure TCtrlGrid2.FormShow(Sender: TObject);
begin
  DMData.qEmp.Open;
  DMData.qEmp.AfterScroll:=AfterScroll;
  CtrlGrid.RowCount:=DMData.qEmp.RecordCount;
  rDBAction.SetActiveGrid(grEmpDummy);
end;

procedure TCtrlGrid2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rDBAction.SetActiveGrid(nil);
  DMData.qEmp.Close;
  DMData.qEmp.AfterScroll:=nil;
end;

procedure TCtrlGrid2.AfterScroll(DataSet: TDataSet);
begin
  if CtrlGrid.PanelHeight * (CtrlGrid.PanelIndex + 1) > ScrollBox.VertScrollBar.Position + ScrollBox.Height then
    ScrollBox.VertScrollBar.Position:=CtrlGrid.PanelHeight * (CtrlGrid.PanelIndex + 1) - ScrollBox.Height + 5;
  if CtrlGrid.PanelHeight * CtrlGrid.PanelIndex < ScrollBox.VertScrollBar.Position then
    ScrollBox.VertScrollBar.Position:=CtrlGrid.PanelHeight * CtrlGrid.PanelIndex;
end;

procedure TCtrlGrid2.CtrlGridPaintPanel(DBCtrlGrid: TrDBCtrlGridEx; Panel: TDBCtrlPanel; Selected, Focused: Boolean);
var
  R: TRect;
begin
  if Selected then
  begin
    R:=Panel.ClientRect;
    if DBCtrlGrid.PanelBorder = gbRaised then
      InflateRect(R, -2, -2);
    DBCtrlGrid.Canvas.Brush.Color:=clHighlight;
    if not Focused then
      DBCtrlGrid.Canvas.FrameRect(R);
    InflateRect(R, -1, -1);
    DBCtrlGrid.Canvas.FrameRect(R);
  end;
end;

procedure TCtrlGrid2.CtrlGridPaintPanelBackground(DBCtrlGrid: TrDBCtrlGridEx; Panel: TDBCtrlPanel; Selected: Boolean; var Color: TColor);
begin
  if DMData.qEmpPartTime.DataType = ftBoolean then
  begin
    if DMData.qEmpPartTime.AsBoolean then
      Color:=clGray;
  end
  else
    if DMData.qEmpPartTime.AsInteger = 1 then
      Color:=clGray;
end;

end.
