unit f_rdbcomps;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, PropSaveMain, PropSaveGrids, DB,
  rImprovedComps, DBCtrls, rDBComponents, ComCtrls, ToolWin, Mask, Buttons,
  rImageZoom, Grids, DBGrids, rDBGrid, rHTMLLabel,
  PropSaveOtherComps, ImgList, rDBColorLinkedComp;

type
  TrDBComps = class(TForm)
    Label2: TrHTMLLabel;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    ImgList1: TImageList;
    gbClient: TrGroupBox;
    grEmp: TrDBGrid;
    rGroupBox1: TrGroupBox;
    rDBMoveButton1: TrDBMoveButton;
    rDBMoveButton2: TrDBMoveButton;
    rDBMoveButton3: TrDBMoveButton;
    rDBMoveButton4: TrDBMoveButton;
    btNew: TrButton;
    btEdit: TrButton;
    btSave: TrButton;
    btCancel: TrButton;
    btDel: TrButton;
    rGroupBox2: TrGroupBox;
    gb1: TrGroupBox;
    eLastName: TrDBEdit;
    eFirstName: TrDBEdit;
    cbTitleOfCourtesy: TrDBComboBox;
    cbTitle: TrDBComboBox;
    cbReportsTo: TrDBLookupComboBox;
    gb4: TrGroupBox;
    lPicInfo: TLabel;
    imgPhoto: TrDBImage;
    gb3: TrGroupBox;
    dtHireDate: TrDBDateTimePicker;
    dtBirthDate: TrDBDateTimePicker;
    chPartTime: TrDBCheckBox;
    eSalary: TrDBEdit;
    gb2: TrGroupBox;
    eAddress: TrDBEdit;
    eCity: TrDBEdit;
    eRegion: TrDBEdit;
    ePostalCode: TrDBEdit;
    eCountry: TrDBEdit;
    eHomePhone: TrDBEdit;
    eExtension: TrDBEdit;
    gb5: TrGroupBox;
    mNotes: TrDBMemoEx;
    rDBRecordSelection1: TrDBRecordSelection;
    btCondFormat: TrURLLabel;
    rDBColorLinkedComp1: TrDBColorLinkedComp;
    chCondFormat: TCheckBox;
    RosiCompsPropSave1: TRosiCompsPropSave;
    dsEmp: TDataSource;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure pcChanging(Sender: TObject; var AllowChange: Boolean);
    procedure AfterUpdate(DataSet: TDataSet);
    procedure dsEmpDataChange(Sender: TObject; Field: TField);
    procedure dsEmpStateChange(Sender: TObject);
    procedure mNotesSubLabelAnchorClick(Sender: TObject; LinkName: string);
    procedure imgPhotoChangeZoom(Sender: TObject);
    procedure btCondFormatClick(Sender: TObject);
    procedure chCondFormatClick(Sender: TObject);
    procedure cbReportsToGetListItemProps(Sender: TObject; Canvas: TCanvas;
      RowIndex, ColIndex: Integer; Selected: Boolean; KeyField,
      ListField: TField; var Width: Integer; Height: Integer; var Text: string;
      ShowBmp: TBitmap; var DrawSeparatorTop, DrawSeparatorBottom: Boolean);
    procedure cbTitleGetListItemProps(Sender: TObject; Canvas: TCanvas;
      Index: Integer; State: TOwnerDrawState; var Rect: TRect; var Text: string;
      ShowBmp: TBitmap; var DrawSeparatorTop, DrawSeparatorBottom: Boolean);
    procedure eAddressRightButtonClick(Sender: TObject);
  private
    procedure LoadLists;
  public
  end;

var
  rDBComps: TrDBComps;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, rstring, rdlg, rtool, rdbtool,
  dm_rdbaction, rDBGridCellParams, dm_rimages;
{$R *.dfm}

procedure TrDBComps.FormShow(Sender: TObject);
begin
  if DMData.qEmpPARTTIME.DataType <> ftBoolean then
  begin
    self.chPartTime.ValueChecked:='1';
    self.chPartTime.ValueUnchecked:='0';
  end;

  LoadLists;
  DMData.qEmp.Close;
  DMData.qEmp.Open;
  DMData.AfterUpdate:=AfterUpdate;
  grEmp.ReSort;
  rDBAction.SetActiveGrid(grEmp);
end;

procedure TrDBComps.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rDBAction.SetActiveGrid(nil);
  DMData.qEmp.Close;
  DMData.AfterUpdate:=nil;
end;

procedure TrDBComps.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=rDBAction.CheckEditState(true);
end;

procedure TrDBComps.LoadLists;
begin
  DMData.qEmpList.Close;
  DMData.qEmpList.Open;
  DMData.qTitleList.Close;
  DMData.qTitleList.Open;
  rdbtool.LoadRecordList(DMData.qTitleListTitle, nil, self.cbTitle.Items);
  DMData.qTitleCList.Close;
  DMData.qTitleCList.Open;
  rdbtool.LoadRecordList(DMData.qTitleCListTitleOfCourtesy, nil, self.cbTitleOfCourtesy.Items);
end;

procedure TrDBComps.mNotesSubLabelAnchorClick(Sender: TObject; LinkName: string);
begin
  ShowMessage(LinkName);
end;

procedure TrDBComps.pcChanging(Sender: TObject; var AllowChange: Boolean);
begin
  AllowChange:=rDBAction.CheckEditState(true);
end;

procedure TrDBComps.AfterUpdate(DataSet: TDataSet);
begin
  LoadLists;
end;

procedure TrDBComps.btCondFormatClick(Sender: TObject);
begin
  rDBGridCellParams.DBGridCellParams(self.grEmp);
  self.rDBColorLinkedComp1.ColorLinkedComps;
end;

procedure TrDBComps.imgPhotoChangeZoom(Sender: TObject);
begin
  lPicInfo.Caption:=imgPhoto.PictureInfo;
end;

procedure TrDBComps.chCondFormatClick(Sender: TObject);
begin
  self.rDBColorLinkedComp1.Enabled:=self.chCondFormat.Checked;
end;

procedure TrDBComps.dsEmpDataChange(Sender: TObject; Field: TField);
begin
  lPicInfo.Caption:=imgPhoto.PictureInfo;
end;

procedure TrDBComps.dsEmpStateChange(Sender: TObject);
begin
  grEmp.Enabled:=not IsEditing(DMData.qEmp);
end;

procedure TrDBComps.eAddressRightButtonClick(Sender: TObject);
begin
  DlgI('Do any action');
end;

procedure TrDBComps.cbTitleGetListItemProps(Sender: TObject; Canvas: TCanvas;
  Index: Integer; State: TOwnerDrawState; var Rect: TRect; var Text: string;
  ShowBmp: TBitmap; var DrawSeparatorTop, DrawSeparatorBottom: Boolean);
begin
  if AnsiPosEx('president', Text) > 0 then
  begin
    Canvas.Font.Style:=[fsBold];
    // define item image
    ShowBmp.Transparent:=true;
    ShowBmp.Width:=Main.GridImg.Width;
    ShowBmp.Height:=Main.GridImg.Height;
    ShowBmp.Canvas.Brush.Color:=clWhite;
    ShowBmp.Canvas.FillRect(Classes.Rect(0, 0, ShowBmp.Width, ShowBmp.Height));
    Main.GridImg.GetBitmap(5, ShowBmp);
  end;
end;

procedure TrDBComps.cbReportsToGetListItemProps(Sender: TObject;
  Canvas: TCanvas; RowIndex, ColIndex: Integer; Selected: Boolean; KeyField,
  ListField: TField; var Width: Integer; Height: Integer; var Text: string;
  ShowBmp: TBitmap; var DrawSeparatorTop, DrawSeparatorBottom: Boolean);
begin
  if ColIndex = 0 then
  begin
    // define item image
    Inc(Width,20);
    ShowBmp.Transparent:=true;
    ShowBmp.Width:=Main.GridImg.Width;
    ShowBmp.Height:=Main.GridImg.Height;
    ShowBmp.Canvas.Brush.Color:=clWhite;
    ShowBmp.Canvas.FillRect(Classes.Rect(0, 0, ShowBmp.Width, ShowBmp.Height));
    Main.GridImg.GetBitmap(0, ShowBmp);
    // test another field from list dataset
    if AnsiPosEx('president',ListField.DataSet.FieldByName('Title').AsString)>0 then
      Canvas.Font.Style:=[fsBold];
  end;
  if ColIndex = 1 then
  begin
    Canvas.Font.Color:=clGrayText;
    if AnsiPosEx('president', Text) > 0 then
    begin
      // define item image
      ShowBmp.Transparent:=true;
      ShowBmp.Width:=Main.GridImg.Width;
      ShowBmp.Height:=Main.GridImg.Height;
      ShowBmp.Canvas.Brush.Color:=clWhite;
      ShowBmp.Canvas.FillRect(Classes.Rect(0, 0, ShowBmp.Width, ShowBmp.Height));
      Main.GridImg.GetBitmap(5, ShowBmp);
    end
    else
    begin
      Text:=Text + ' (!)';
    end;
  end;

end;

end.
